$(document).ready(function(){

	/* 
		AUTOMATIC CLASSES
			comparePasswords		-	compare password fields .password1 and .password2
			checkRequired		-	checks all '.required' fields | email field should be .email
			autoajax		-	checks all '.required' fields and submits the form via AJAX with POST | email field should be .email
	*/
		
	// faux select form element
		/*
			SAMPLE HTML
			<div class="fauxselectblock">
				<a href="#" class="fauxselect"><span>Select...</span> <i class="fa fa-chevron-down"></i></a>
				<ul data-valfield="#txtFormField" class="fauxoptions hideforload">
					<li><a href="#" data-val="VALUE" class="fauxselectoption">LABEL</a></li>
					<li><a href="#" data-val="VALUE" class="fauxselectoption">LABEL</a></li>
					<li><a href="#" data-val="VALUE" class="fauxselectoption">LABEL</a></li>
				</ul>
			</div>
			<input id="txtFormField" name="p" type="hidden" />
			.fauxselectblock{ position: relative; display: inline-block; width: 25%; margin-right: 10px; vertical-align: top; }
				.fauxselectblock>a{ display: block; padding: 10px; background-color: #ffffff; color: #4c4c4c; font-size: 18px; overflow: hidden; text-decoration: none; }
					.fauxselectblock>a:hover{ box-shadow: 0 0 10px rgba(0,0,0,0.3); }
					.fauxselectblock>a .fa{ float: right; color: #3dc4ac; }
				.fauxselectblock>ul{ position: absolute; left: 0; top: 38px; display: block; padding: 0 0 10px; width: 100%; background-color: #ffffff; }
					.fauxselectblock>ul li{ display: block; padding: 0; }
						.fauxselectblock>ul li a{ display: block; padding: 5px 10px; color: #4c4c4c; font-size: 18px; text-decoration: none; }
							.fauxselectblock>ul li a:hover{ background-color: #eeeeee; color: #3dc4ac; }
		*/
		$('.fauxselectblock').on('click','.fauxselect',function(e){
			e.preventDefault();
			var link	=	$(this);
			$(this).siblings('ul').slideToggle(function(){
				if($(this).is(':visible')){
					link.find('.fa').removeClass('fa-chevron-down').addClass('fa-chevron-up');
				}
				else{
					link.find('.fa').removeClass('fa-chevron-up').addClass('fa-chevron-down');
				}
			});
		});
		$('.fauxoptions').on('click','.fauxselectoption',function(e){
			e.preventDefault();
			var valtarget	=	$(this).closest('.fauxoptions').data('valfield');
			var linkval		=	$(this).data('val');
			$(valtarget).val(linkval);
			$(this).closest('.fauxoptions').siblings('.fauxselect').find('span').html($(this).html());
			$(this).closest('.fauxoptions').slideUp(function(){
				var chevronicon	=	$(this).siblings('.fauxselect').find('.fa');
				chevronicon.removeClass('fa-chevron-up').addClass('fa-chevron-down');
			});
		});
	
	// display pane
		$('#displaypane').on('click','.close',function(e){
			e.preventDefault();
			$('#displaypane #innerpane').html('');
			$('#displaypane').slideUp();
		});
		
	// tabs
		$('.tabs').on('click','a',function(e){
			e.preventDefault();
			if($(this).not('.selected')){
				var targettab	=	$(this).attr('href');
				$('.tabs a.selected').removeClass('selected');
				$(this).addClass('selected');
				$('.tab.active').hide();
				$(targettab).fadeIn().addClass('active');
			}
		});
		
	// hide status message
		$('#statusmessage').delay(5000).slideUp(function(){
			$.ajax({
				type: "GET",
				url: basepath+'action/base/clearMsg/'
				,data: '',
				success: function(html){
					// console.log(html);
				}
			});	
		});
		$('#statusmessage').click(function(){ 
			$(this).stop().slideUp(); 
			$.ajax({
				type: "GET",
				url: basepath+'action/base/clearMsg/'
				,data: '',
				success: function(html){
					// console.log(html);
				}
			});
		});
		
	// no follow parent link
		$('a.nofollow').click(function(){ return false; });
		
	// scroll to section on same page link
		$('a.scrolllink').click(function(e){ 
			e.preventDefault();
			var target	=	'#'+$(this).data('scrolltarget');
			$('html, body').animate({ scrollTop: $(target).offset().top-30 }, 500);
		});
	
	// runtime data validation
		$('.numbersonly').keyup(function () { this.value = this.value.replace(/[^0-9\.]/g,''); });
		$('.phonenumberonly').keyup(function () { this.value = this.value.replace(/[^0-9\.\s\+\(\)\-]/g,''); });
		$('.urlstronly').keyup(function () { this.value = this.value.replace(/[^0-9a-zA-Z\s\-]/g,''); });
	
	// generic hide/show elements
		$('.hide').hide();
		$('.hideforload').removeClass('hideforload').hide();
		$('.faded').fadeOut(0);
		
		// simple show/hide with scroll
			$('.show').click(function(){
				var link	=	$(this);
				elmid		=	$(this).attr('href');
				$(elmid).slideToggle(function(){
					var isHidden=	$(elmid).is(':hidden');
					if(isHidden){
						$(link).addClass('closed').removeClass('open');
					}
					else{
						$(link).addClass('open').removeClass('closed');
					}
				});
				if(!link.hasClass('noscroll'))$('html, body').animate({ scrollTop: $(this).offset().top-30 }, 500);
				return false;
			});

	// generic response row
		$('.response').hide();
		
	// enable disabled submit buttons
		$('#bttAdd:disabled').prop('disabled',false);
		$('#bttUpdate:disabled').prop('disabled',false);
		
	// automatic form validations
		$('form.checkRequired input[type=submit],form.checkRequired button[type=submit]').click(function(){
			// formid	=	'#'+$(this).parent().parent().parent().attr('id');	// form > ul > li
			$(this).prop('disabled',true);
			formid	=	'#'+$(this).closest('form').attr('id');
				
			if(checkFields(formid)>0){
				custommsg	=	$(formid).data('failmsg');
				if(!custommsg){
					if(lang=='fr'){
						$(formid).find('.response').html('Veuillez renseigner les champs surlignés');
					}
					else{
						$(formid).find('.response').html('Please complete the highlighted fields');
					}
				}
				else{
					$(formid).find('.response').html(custommsg);
				}
				$(formid).find('.response').slideDown();
				$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
				$(this).prop('disabled',false);
				return false;
			}
			else{
			
				if($(formid).hasClass('comparePasswords')){
					$(this).prop('disabled',false);
					if($(formid+' .password1').val().length<6){
						$(formid).find('.response').html('Your password needs to be at least 6 characters long');
						$(formid).find('.response').slideDown();
						$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
						return false;
					}
					if($(formid+' .password1').val()!=$(formid+' .password2').val()){
						$(formid).find('.response').html('The passwords you have entered do not match');
						$(formid).find('.response').slideDown();
						$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
						return false;
					}
				}
			
				$(formid).submit();
			}
		});
		
	// automatic AJAX forms
		$('form.autoajax input[type=submit],form.autoajax button[type=submit]').click(function(){

			// formid	=	'#'+$(this).parent().parent().parent().attr('id');	// form > ul > li
			$(this).prop('disabled',true);
			formid	=	'#'+$(this).closest('form').attr('id');
			
			if(checkFields(formid)>0){
				custommsg	=	$(formid).data('failmsg');
				if(!custommsg){
					if(lang=='fr'){
						$(formid).find('.response').html('Veuillez renseigner les champs surlignés');
					}
					else{
						$(formid).find('.response').html('Please complete the highlighted fields');
					}
				}
				else{
					$(formid).find('.response').html(custommsg);
				}
				$(formid).find('.response').slideDown();
				$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
				$(this).prop('disabled',false);
				return false;
			}
			
			if($(formid).hasClass('comparePasswords')){
				$(this).prop('disabled',false);
				if($('.password1').val().length<6){
					$(formid).find('.response').html('Your password needs to be at least 6 characters long');
					$(formid).find('.response').slideDown();
					$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
					return false;
				}
				if($('.password1').val()!=$('.password2').val()){
					$(formid).find('.response').html('The passwords you have entered do not match');
					$(formid).find('.response').slideDown();
					$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);
					return false;
				}
			}
			
			// get action
				actionstr=$(formid).attr('action');
				
			// build POST
				datastr	=	'';
				
				// hidden fields
				$(formid).find('input[type=hidden]').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// text fields
				$(formid).find('input[type=text]').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// password fields
				$(formid).find('input[type=password]').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// checkboxes
				$(formid).find('input[type=checkbox]:checked').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// radio buttons
				$(formid).find('input[type=radio]:checked').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// textareas
				$(formid).find('textarea').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });
				
				// selects
				$(formid).find('select').each(function(){ fieldname=$(this).attr('name'); fieldval=$(this).val(); datastr=datastr+fieldname+'='+fieldval+'&'; });

				
			$(formid).find('li input').attr('disabled','disabled');
			$(formid).find('li input[type=submit]').fadeOut();
			$(formid).find('.response').html('Loading... Please wait...');
			$(formid).find('.response').slideDown();
			$('html, body').animate({ scrollTop: $($(formid).find('.response')).offset().top-100 }, 500);

			
			$.ajax({
				type: "POST",
				url: actionstr,
				data: datastr,
				success: function(html){
					$(formid).find('.response').html(html);
					$(formid).find('li').not('.response,.title').fadeOut();
				}
			});
		});
});

function checkFields(formid){
	var errors=0;
	formid=formid+' .required';
	$(formid).each(function(){
		
		// check for any entry
			if($(this).val()==''){
				errors++;
				$(this).addClass('highlight');
				$(this).closest('li.section').find('a.show').addClass('highlight');
			}
			else{
				$(this).removeClass('highlight');
				$(this).closest('li.section').find('a.show').removeClass('highlight');
			}
			
		// check select
			if($(this).hasClass('select')){
				if($(this).val()==0||(!$(this).val())){
					errors++;
					$(this).addClass('highlight');
				}
				else{
					$(this).removeClass('highlight');
				}
			}
			
		// check email format
			if($(this).hasClass('email')){
				if(!isEmail($(this).val())){
					errors++;
					$(this).addClass('highlight');
				}
				else{
					$(this).removeClass('highlight');
				}
			}
			
		// check checkbox
			if($(this).hasClass('checkbox')){
				if(!$(this).is(':checked')){
					$(this).addClass('highlight');
					errors++;
				}
				else{
					$(this).removeClass('highlight');
				}
			}
			
			
	});
	return errors;
}
function isEmail(t){
	var s	=	t.trim();  
	var filter=/^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
	if (filter.test(s)){
		return true;
	}
	else{
		return false;
	}
}
function commafy(x){ return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ","); }
function getPathLengths(elmid){
	const elm	=	document.querySelectorAll('#'+elmid+' path');
	for(let i=0;i<elm.length;i++){
		console.log(`Path ${i} length is ${elm[i].getTotalLength()}`);
	}
}






